/*****************************************************************/
/*  Módulo de gestión de las funciones callback que se producen  */
/*  cuando sucede un evento que se está monitorizando            */
/*****************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

#include "callbacks.h"
#include "clearbox.h"
#include "dialogs.h"
#include "preview.h"
#include "xmlfile.h"


/* Funciones callback de la ventana principal de la aplicación */

gboolean on_windowClearbox_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  end_clearbox ();
  return FALSE;
}

void on_radiobuttonGeneralStyleFlat_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_general ();
}

void on_radiobuttonGeneralStyleOut_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_general ();
}

void on_radiobuttonGeneralStyleIn_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_general ();
}

void on_radiobuttonBordersStyleSquare_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_corners ();
}

void on_radiobuttonBordersStyleRounded_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_corners ();
}

void on_spinbuttonBordersOptionsWidth_changed (GtkEditable *editable, gpointer user_data)
{
  set_options_border ();
}

void on_checkbuttonBordersOptionsOutline_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_border ();
}

void on_checkbuttonBordersOptionsColorized_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_border ();
}

void on_radiobuttonControlsStyleSimple_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_controls ();
}

void on_radiobuttonControlsStyleDark_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_controls ();
}

void on_radiobuttonControlsStyleClear_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_controls ();
}

void on_radiobuttonColorsGTK_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_colors ();
}

void on_radiobuttonColorsCustom_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
  set_options_colors ();
}

void on_buttonActionsAbout_clicked (GtkButton *button, gpointer user_data)
{
  open_about_dialog ();
}

void on_buttonActionsPreview_clicked (GtkButton *button, gpointer user_data)
{
  if (write_xml_file ("Clearbox-temp"))
    preview_theme ("Clearbox-temp");
}

void on_buttonActionsSave_clicked (GtkButton *button, gpointer user_data)
{
  open_save_dialog ();
}

/* Funciones callback del diálogo de Guardar tema */

gboolean on_windowSave_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  close_save_dialog ();
  return FALSE;
}

void on_entrySaveName_changed (GtkEditable *editable, gpointer user_data)
{
  set_options_save ();
}

void on_buttonSaveCancel_clicked (GtkButton *button, gpointer user_data)
{
  close_save_dialog ();
}

void on_buttonSaveSave_clicked (GtkButton *button, gpointer user_data)
{
  save_theme ();
}

/* Funciones callback del diálogo de Error */

gboolean on_windowError_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  close_error_dialog ();
  return FALSE;
}

void on_buttonErrorClose_clicked (GtkButton *button, gpointer user_data)
{
  close_error_dialog ();
}
