/****************************************************************/
/*  Módulo de gestión de la ventana principal de la aplicación  */
/****************************************************************/

#include <gtk/gtk.h>
#include <glib/gstdio.h>
#include <glib/gprintf.h>
#include <unistd.h>

#include "interface.h"
#include "support.h"

#include "clearbox.h"


/* Widgets de la ventana principal de la aplicación */

static GtkWidget *windowClearbox = NULL;
static GtkWidget *radiobuttonGeneralStyleFlat = NULL;
static GtkWidget *radiobuttonGeneralStyleOut = NULL;
static GtkWidget *radiobuttonGeneralStyleIn = NULL;
static GtkWidget *vboxGeneralGradientOptions = NULL;
static GtkWidget *radiobuttonGeneralGradientSoft = NULL;
static GtkWidget *radiobuttonGeneralGradientNormal = NULL;
static GtkWidget *radiobuttonGeneralGradientStrong = NULL;
static GtkWidget *radiobuttonBordersStyleSquare = NULL;
static GtkWidget *radiobuttonBordersStyleRounded = NULL;
static GtkWidget *spinbuttonBordersOptionsWidth = NULL;
static GtkWidget *checkbuttonBordersOptionsOutline = NULL;
static GtkWidget *checkbuttonBordersOptionsColorized = NULL;
static GtkWidget *checkbuttonBordersOptions3D = NULL;
static GtkWidget *radiobuttonTitlePositionLeft = NULL;
static GtkWidget *radiobuttonTitlePositionCenter = NULL;
static GtkWidget *checkbuttonTitleOptionsShadow = NULL;
static GtkWidget *radiobuttonControlsStyleSimple = NULL;
static GtkWidget *radiobuttonControlsStyleDark = NULL;
static GtkWidget *radiobuttonControlsStyleClear = NULL;
static GtkWidget *comboboxControlsOptionsSize = NULL;
static GtkWidget *comboboxControlsOptionsGap = NULL;
static GtkWidget *checkbuttonControlsOptionsIcon = NULL;
static GtkWidget *radiobuttonColorsGTK = NULL;
static GtkWidget *radiobuttonColorsCustom = NULL;
static GtkWidget *tableColorsCustom = NULL;
static GtkWidget *colorbuttonColorsCustomBase = NULL;
static GtkWidget *colorbuttonColorsCustomTitle1 = NULL;
static GtkWidget *colorbuttonColorsCustomTitle2 = NULL;
static GtkWidget *colorbuttonColorsCustomButtons1 = NULL;
static GtkWidget *colorbuttonColorsCustomButtons2 = NULL;
static GtkWidget *colorbuttonColorsCustomButtons3 = NULL;


/* Arranca la aplicación
   Inicializa y muestra la ventana principal */
   
void start_clearbox ()
{
  GdkColor colorBase = {0, 0x7CFF, 0x99FF, 0xADFF};
  GdkColor colorTitleFocused = {0, 0xFFFF, 0xFFFF, 0xFFFF};
  GdkColor colorTitleUnfocused = {0, 0xC1FF, 0xD3FF, 0xDFFF};
  GdkColor colorButtonFocused = {0, 0xFFFF, 0xFFFF, 0xFFFF};
  GdkColor colorButtonUnfocused = {0, 0xC1FF, 0xD3FF, 0xDFFF};
  GdkColor colorButtonPressed = {0, 0xFFFF, 0xFFFF, 0x0000};
  
  windowClearbox = create_windowClearbox ();

  radiobuttonGeneralStyleFlat = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonGeneralStyleFlat");
  radiobuttonGeneralStyleOut = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonGeneralStyleOut");
  radiobuttonGeneralStyleIn = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonGeneralStyleIn");
  vboxGeneralGradientOptions = lookup_widget (GTK_WIDGET(windowClearbox), "vboxGeneralGradientOptions");
  radiobuttonGeneralGradientSoft = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonGeneralGradientSoft");
  radiobuttonGeneralGradientNormal = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonGeneralGradientNormal");
  radiobuttonGeneralGradientStrong = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonGeneralGradientStrong");
  radiobuttonBordersStyleSquare = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonBordersStyleSquare");
  radiobuttonBordersStyleRounded = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonBordersStyleRounded");
  spinbuttonBordersOptionsWidth = lookup_widget (GTK_WIDGET(windowClearbox), "spinbuttonBordersOptionsWidth");
  checkbuttonBordersOptionsOutline = lookup_widget (GTK_WIDGET(windowClearbox), "checkbuttonBordersOptionsOutline");
  checkbuttonBordersOptionsColorized = lookup_widget (GTK_WIDGET(windowClearbox), "checkbuttonBordersOptionsColorized");
  checkbuttonBordersOptions3D = lookup_widget (GTK_WIDGET(windowClearbox), "checkbuttonBordersOptions3D");
  radiobuttonTitlePositionLeft = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonTitlePositionLeft");
  radiobuttonTitlePositionCenter = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonTitlePositionCenter");
  checkbuttonTitleOptionsShadow = lookup_widget (GTK_WIDGET(windowClearbox), "checkbuttonTitleOptionsShadow");
  radiobuttonControlsStyleSimple = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonControlsStyleSimple");
  radiobuttonControlsStyleDark = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonControlsStyleDark");
  radiobuttonControlsStyleClear = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonControlsStyleClear");
  comboboxControlsOptionsSize = lookup_widget (GTK_WIDGET(windowClearbox), "comboboxControlsOptionsSize");
  comboboxControlsOptionsGap = lookup_widget (GTK_WIDGET(windowClearbox), "comboboxControlsOptionsGap");
  checkbuttonControlsOptionsIcon = lookup_widget (GTK_WIDGET(windowClearbox), "checkbuttonControlsOptionsIcon");
  radiobuttonColorsGTK = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonColorsGTK");
  radiobuttonColorsCustom = lookup_widget (GTK_WIDGET(windowClearbox), "radiobuttonColorsCustom");
  tableColorsCustom = lookup_widget (GTK_WIDGET(windowClearbox), "tableColorsCustom");
  colorbuttonColorsCustomBase = lookup_widget (GTK_WIDGET(windowClearbox), "colorbuttonColorsCustomBase");
  colorbuttonColorsCustomTitle1 = lookup_widget (GTK_WIDGET(windowClearbox), "colorbuttonColorsCustomTitle1");
  colorbuttonColorsCustomTitle2 = lookup_widget (GTK_WIDGET(windowClearbox), "colorbuttonColorsCustomTitle2");
  colorbuttonColorsCustomButtons1 = lookup_widget (GTK_WIDGET(windowClearbox), "colorbuttonColorsCustomButtons1");
  colorbuttonColorsCustomButtons2 = lookup_widget (GTK_WIDGET(windowClearbox), "colorbuttonColorsCustomButtons2");
  colorbuttonColorsCustomButtons3 = lookup_widget (GTK_WIDGET(windowClearbox), "colorbuttonColorsCustomButtons3");

  gtk_combo_box_set_active (GTK_COMBO_BOX(comboboxControlsOptionsSize), 0);
  gtk_combo_box_set_active (GTK_COMBO_BOX(comboboxControlsOptionsGap), 0);
  
  gtk_color_button_set_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomBase), &colorBase);
  gtk_color_button_set_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomTitle1), &colorTitleFocused);
  gtk_color_button_set_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomTitle2), &colorTitleUnfocused);
  gtk_color_button_set_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomButtons1), &colorButtonFocused);
  gtk_color_button_set_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomButtons2), &colorButtonUnfocused);
  gtk_color_button_set_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomButtons3), &colorButtonPressed);
  
  gtk_widget_show (windowClearbox);
}

/* Finaliza la aplicación
   Borra el directorio temporal creado para previsualizar el tema */

void end_clearbox ()
{
  gchar *tempPath;
  gchar *metacityPath;
  gchar *filePath;
  
  tempPath = g_build_path ("/", g_get_home_dir (), ".themes", "Clearbox-temp", NULL);
  metacityPath = g_build_path ("/", tempPath, "metacity-1", NULL);
  filePath = g_build_path ("/", metacityPath, "metacity-theme-1.xml", NULL);
  
  if (g_file_test (tempPath, G_FILE_TEST_IS_DIR))
  {
    g_unlink (filePath);
    g_rmdir (metacityPath);
    g_rmdir (tempPath);
  }
  
  g_free (tempPath);
  g_free (metacityPath);
  g_free (filePath);

  gtk_main_quit ();
}

/* Establece el estado de los widgets dependientes en la pestaña General */

void set_options_general ()
{
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonGeneralStyleFlat)))
    gtk_widget_set_sensitive (vboxGeneralGradientOptions, FALSE);
  else
    gtk_widget_set_sensitive (vboxGeneralGradientOptions, TRUE);
}

/* Establece el estado de los widgets dependientes en la pestaña Bordes */

void set_options_corners ()
{
  gboolean roundedCorners;
  gint borderWidth;

  roundedCorners = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonBordersStyleRounded));
  borderWidth = gtk_spin_button_get_value (GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth));
  
  if (roundedCorners)
  {
    gtk_spin_button_set_range (GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth), 4, 8);
    if (borderWidth < 4)
      gtk_spin_button_set_value (GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth), 4);
    else
      gtk_spin_button_set_value (GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth), borderWidth);
  }
  else
  {
    gtk_spin_button_set_range (GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth), 1, 8);
    gtk_spin_button_set_value (GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth), borderWidth);
  }
  
}

/* Establece el estado de los widgets dependientes en la pestaña Bordes */

void set_options_border ()
{
  gint borderWidth;
  gboolean interiorOutline;
  gboolean colorizedBorders;
  
  borderWidth = gtk_spin_button_get_value (GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth));
  interiorOutline = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbuttonBordersOptionsOutline));
  colorizedBorders = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbuttonBordersOptionsColorized));
  
  if (borderWidth <= 3)
  {
    gtk_widget_set_sensitive (checkbuttonBordersOptions3D, FALSE);
    if (borderWidth == 1)
    {
      gtk_widget_set_sensitive (checkbuttonBordersOptionsColorized, FALSE);
    }
    else
    {
      gtk_widget_set_sensitive (checkbuttonBordersOptionsColorized, TRUE);
    }
  }
  else
  {
    gtk_widget_set_sensitive (checkbuttonBordersOptionsOutline, TRUE);
    gtk_widget_set_sensitive (checkbuttonBordersOptionsColorized, TRUE);
    if (interiorOutline && colorizedBorders)
      gtk_widget_set_sensitive (checkbuttonBordersOptions3D, TRUE);
    else
      gtk_widget_set_sensitive (checkbuttonBordersOptions3D, FALSE);
  }
}

/* Establece el estado de los widgets dependientes en la pestaña Controles */

void set_options_controls ()
{
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonControlsStyleSimple)))
    gtk_widget_set_sensitive (comboboxControlsOptionsSize, TRUE);
  else
    gtk_widget_set_sensitive (comboboxControlsOptionsSize, FALSE);
}

/* Establece el estado de los widgets dependientes en la pestaña Colores */

void set_options_colors ()
{
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonColorsGTK)))
    gtk_widget_set_sensitive (tableColorsCustom, FALSE);
  else
    gtk_widget_set_sensitive (tableColorsCustom, TRUE);
}

/* Lee las opciones seleccionadas por el usuario
   y las guarda en la estructura que se le pasa */

void read_options (struct CLEARBOX_PREFS *prefs)
{
  GdkColor colorBase = {0, 0x7CFF, 0x99FF, 0xADFF};
  GdkColor colorTitleFocused = {0, 0xFFFF, 0xFFFF, 0xFFFF};
  GdkColor colorTitleUnfocused = {0, 0xC1FF, 0xD3FF, 0xDFFF};
  GdkColor colorButtonFocused = {0, 0xFFFF, 0xFFFF, 0xFFFF};
  GdkColor colorButtonUnfocused = {0, 0xC1FF, 0xD3FF, 0xDFFF};
  GdkColor colorButtonPressed = {0, 0xFFFF, 0xFFFF, 0x0000};
  
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonGeneralStyleFlat)))
    prefs->topbarStyle = FLAT;
  else
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonGeneralStyleIn)))
      prefs->topbarStyle = CLEARBOX_IN;
    else
      prefs->topbarStyle = CLEARBOX_OUT;
    
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonGeneralGradientNormal)))
    prefs->gradientIntensity = NORMAL;
  else
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonGeneralGradientStrong)))
      prefs->gradientIntensity = STRONG;
    else
      prefs->gradientIntensity = SOFT;

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonBordersStyleRounded)))
    prefs->frameStyle = ROUNDED_CORNERS;
  else
    prefs->frameStyle = SQUARE_CORNERS;
  
  prefs->borderWidth = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbuttonBordersOptionsWidth));
  prefs->interiorOutline = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbuttonBordersOptionsOutline));
  if (prefs->borderWidth < 2)
    prefs->borderColorized = FALSE;
  else
    prefs->borderColorized = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbuttonBordersOptionsColorized));
  if ((prefs->borderWidth < 4) || (!prefs->interiorOutline) || (!prefs->borderColorized))
    prefs->border3D = FALSE;
  else
    prefs->border3D = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbuttonBordersOptions3D));
  
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonTitlePositionCenter)))
    prefs->titlePosition = CENTER;
  else
    prefs->titlePosition = LEFT;
  
  prefs->titleShadow = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbuttonTitleOptionsShadow));

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonControlsStyleDark)))
    prefs->buttonStyle = DARK_FRAME;
  else
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonControlsStyleClear)))
      prefs->buttonStyle = CLEAR_FRAME;
    else
      prefs->buttonStyle = SIMPLE;

  if (prefs->buttonStyle == SIMPLE)
    prefs->buttonSize = gtk_combo_box_get_active (GTK_COMBO_BOX(comboboxControlsOptionsSize));
  else
    prefs->buttonSize = SMALL;
  prefs->buttonGap = gtk_combo_box_get_active (GTK_COMBO_BOX(comboboxControlsOptionsGap));
  prefs->buttonIcon = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbuttonControlsOptionsIcon));

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(radiobuttonColorsGTK)))
    prefs->colorsGTK = TRUE;
  else
    prefs->colorsGTK = FALSE;
  
  gtk_color_button_get_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomBase), &colorBase);
  gtk_color_button_get_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomTitle1), &colorTitleFocused);
  gtk_color_button_get_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomTitle2), &colorTitleUnfocused);
  gtk_color_button_get_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomButtons1), &colorButtonFocused);
  gtk_color_button_get_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomButtons2), &colorButtonUnfocused);
  gtk_color_button_get_color (GTK_COLOR_BUTTON(colorbuttonColorsCustomButtons3), &colorButtonPressed);
  
  if (prefs->colorsGTK)
  {
    g_sprintf (prefs->colorBase, "%s", "gtk:bg[SELECTED]");
    g_sprintf (prefs->colorTitleFocused, "%s", "gtk:fg[SELECTED]");
    g_sprintf (prefs->colorTitleUnfocused, "%s", "shade/gtk:bg[SELECTED]/1.4");
    if (prefs->buttonStyle == CLEAR_FRAME)
    {
      g_sprintf (prefs->colorButtonFocused, "%s", "shade/gtk:bg[SELECTED]/0.6");
      g_sprintf (prefs->colorButtonUnfocused, "%s", "shade/gtk:bg[SELECTED]/0.6");
      g_sprintf (prefs->colorButtonPressed, "%s", "shade/gtk:bg[SELECTED]/0.6");
    }
    else
    {
      g_sprintf (prefs->colorButtonFocused, "%s", "gtk:fg[SELECTED]");
      g_sprintf (prefs->colorButtonUnfocused, "%s", "shade/gtk:bg[SELECTED]/1.4");
      g_sprintf (prefs->colorButtonPressed, "%s", "#FFFF00");
    }
  }
  else
  {
    g_sprintf (prefs->colorBase, "#%02X%02X%02X", colorBase.red/256, colorBase.green/256, colorBase.blue/256);
    g_sprintf (prefs->colorTitleFocused, "#%02X%02X%02X", colorTitleFocused.red/256, colorTitleFocused.green/256, colorTitleFocused.blue/256);
    g_sprintf (prefs->colorTitleUnfocused, "#%02X%02X%02X", colorTitleUnfocused.red/256, colorTitleUnfocused.green/256, colorTitleUnfocused.blue/256);
    g_sprintf (prefs->colorButtonFocused, "#%02X%02X%02X", colorButtonFocused.red/256, colorButtonFocused.green/256, colorButtonFocused.blue/256);
    g_sprintf (prefs->colorButtonUnfocused, "#%02X%02X%02X", colorButtonUnfocused.red/256, colorButtonUnfocused.green/256, colorButtonUnfocused.blue/256);
    g_sprintf (prefs->colorButtonPressed, "#%02X%02X%02X", colorButtonPressed.red/256, colorButtonPressed.green/256, colorButtonPressed.blue/256);
  }
}
