/****************************************************************/
/*  Módulo de gestión de la ventana principal de la aplicación  */
/****************************************************************/

#include <gtk/gtk.h>


enum TopbarStyle {FLAT, CLEARBOX_OUT, CLEARBOX_IN};
enum GradientIntensity {SOFT, NORMAL, STRONG};
enum FrameStyle {SQUARE_CORNERS, ROUNDED_CORNERS};
enum TitlePosition {LEFT, CENTER};
enum ButtonsStyle {SIMPLE, DARK_FRAME, CLEAR_FRAME};
enum ButtonSize {SMALL, MEDIUM, LARGE};

/* Modelo de estructura que contiene las preferencias del tema */

struct CLEARBOX_PREFS
{
  gint topbarStyle;
  gint gradientIntensity;
  gint frameStyle;
  gint borderWidth;
  gboolean interiorOutline;
  gboolean borderColorized;
  gboolean border3D;
  gint titlePosition;
  gboolean titleShadow;
  gint buttonStyle;
  gint buttonSize;
  gint buttonGap;
  gboolean buttonIcon;
  gboolean colorsGTK;
  gchar colorBase[64];
  gchar colorTitleFocused[32];
  gchar colorTitleUnfocused[32];
  gchar colorButtonFocused[32];
  gchar colorButtonUnfocused[32];
  gchar colorButtonPressed[32];
};

/* Declaración de funciones del módulo clearbox.c */

void start_clearbox ();
void end_clearbox ();
void set_options_general ();
void set_options_corners ();
void set_options_border ();
void set_options_controls ();
void set_options_colors ();
void read_options (struct CLEARBOX_PREFS *prefs);
