/*****************************************/
/*  Módulo de previsualización del tema  */
/*****************************************/

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

#include "dialogs.h"
#include "preview.h"


/* Previsualiza el tema con las opciones elegidas
   Utiliza el programa marco-theme-viewer lanzándolo como proceso */
   
gboolean preview_theme (gchar *theme)
{
  gboolean result;
  GString *process;
  gchar **argv;
  GPid pid;
  GError *error = NULL;
  
  process = g_string_new ("marco-theme-viewer ");
  g_string_append (process, theme);
  argv = g_strsplit (process->str, " ", -1);
  
  result = g_spawn_async (NULL, argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &pid, &error);

  if (!result)
  {
    open_error_dialog (_("Clearbox preview error"), error->message);
    g_error_free (error);
    error = NULL;
  }

  g_strfreev (argv);
  return (result);
}
